﻿using System;
using System.Collections.Generic;
using System.IO;
using System.Net.Mime;
using System.Security.Cryptography;
using System.Text;

namespace RSA
{
    class Program
    {
        static void Main(string[] args)
        {


            Console.WriteLine("开始......");
            DateTime startTime = DateTime.Now;
            
            for (int i = 0; i < 1000; i++)
            {

                #region RSA
                //string[] keys = RSAHelper.GenerateKeys();
                //Console.WriteLine("public key:" + keys[1]);
                //Console.WriteLine();
                //Console.WriteLine("private key:" + keys[0]);
                //Console.WriteLine(new string('.', 50));
                //string nativeString = "cbcye.com";
                //Console.WriteLine("Native String -> " + nativeString);
                //string encryptString = RSAHelper.EncryptString(nativeString, keys[1]);
                //Console.WriteLine("Encrypt -> " + encryptString);
                //Console.WriteLine();
                //string descryptString = RSAHelper.DecryptString(encryptString, keys[0]);
                //Console.WriteLine("Decrypt -> " + descryptString);
                //Console.WriteLine(new string('.', 50));
                //Console.WriteLine("completed...");
                #endregion

                #region RSA Saved to File

                //RSACryptoServiceProvider rsa = new RSACryptoServiceProvider();
                //RSAParameters keys = rsa.ExportParameters(true);
                //String pkxml = "<root>\n<Modulus>" + Convert.ToBase64String(keys.Modulus) + "</Modulus>";
                //pkxml += "\n<Exponent>" + Convert.ToBase64String(keys.Exponent) + "</Exponent>\n</root>";

                //String psxml = "<root>\n<Modulus>" + Convert.ToBase64String(keys.Modulus) + "</Modulus>";
                //psxml += "\n<Exponent>" + Convert.ToBase64String(keys.Exponent) + "</Exponent>";
                //psxml += "\n<D>" + Convert.ToBase64String(keys.D) + "</D>";
                //psxml += "\n<DP>" + Convert.ToBase64String(keys.DP) + "</DP>";
                //psxml += "\n<P>" + Convert.ToBase64String(keys.P) + "</P>";
                //psxml += "\n<Q>" + Convert.ToBase64String(keys.Q) + "</Q>";
                //psxml += "\n<DQ>" + Convert.ToBase64String(keys.DQ) + "</DQ>";
                //psxml += "\n<InverseQ>" + Convert.ToBase64String(keys.InverseQ) + "</InverseQ>\n</root>";

                //Console.WriteLine(rsa.ToXmlString(true));
                ////if(argv.Length>0&&argv[0]=="SaveToFile"){
                //SaveToFile("publickey.xml", pkxml);
                //SaveToFile("privatekey.xml", psxml);
                //Console.WriteLine("RSA Key保存成功！");

                //Console.WriteLine("PublicKey:\n" + pkxml);
                //Console.WriteLine("\nPrivateKey:\n" + psxml);

                //Console.WriteLine("\n加密解密测试:\n===========================");
                //RSAHandler rsahd = new RSAHandler();
                //RSACryptoServiceProvider rsaprd = rsahd.CreateRSAProvider("privatekey.xml");
                //RSACryptoServiceProvider rsaprd1 = rsahd.CreateRSAEncryptProvider("publickey.xml");
                //String text = new string('c',16);
                //Console.WriteLine("1.明文:\n" + text);
                //byte[] data = new UnicodeEncoding().GetBytes(text);
                //byte[] endata = rsaprd1.Encrypt(data, true);
                //Console.WriteLine("2.publicKey加密后的数据:\n" + Convert.ToBase64String(endata));
                //byte[] dedata = rsaprd.Decrypt(endata, true);
                //Console.WriteLine("3.privateKey解密后的数据:\n" + (new UnicodeEncoding()).GetString(dedata));
                #endregion

                #region DES
                //string key = DESHelper.GenerateKey();
                //Console.WriteLine("Key -> " + key);
                //Console.WriteLine();
                //string nativeString = "cbcye.com";
                //Console.WriteLine("Native String -> " + nativeString);
                //string encryptString = DESHelper.EncryptString(nativeString, key);
                //Console.WriteLine("Encrypt -> " + encryptString);
                //Console.WriteLine();
                //string descryptString = DESHelper.DecryptString(encryptString, key);
                //Console.WriteLine("Decrypt -> " + descryptString);
                //Console.WriteLine(new string('.', 50));
                #endregion

                #region AES
                //string key = new string('c',32); //256位
                //string key = new string('c', 24); //192位
                //string key = new string('c', 16); // 128位
                //Console.WriteLine("Key -> " + key);
                //Console.WriteLine();
                //string nativeString = "cbcye.com";
                //Console.WriteLine("Native String -> " + nativeString);
                //string encryptString = AESHelper.EncryptString(nativeString, key);
                //Console.WriteLine("Encrypt -> " + encryptString);
                //Console.WriteLine();
                //string descryptString = AESHelper.DecryptString(encryptString, key);
                //Console.WriteLine("Decrypt -> " + descryptString);
                //Console.WriteLine(new string('.', 50));
                #endregion

                #region 综合应用
                /*使用RSA生成公钥和私钥
             * 消息内容使用AES加、解密
             * 对称密钥使用RSA进行加、解密 
             */
                //RSACryptoServiceProvider rsa = new RSACryptoServiceProvider();
                //RSAParameters keys = rsa.ExportParameters(true);
                //String pkxml = "<root>\n<Modulus>" + Convert.ToBase64String(keys.Modulus) + "</Modulus>";
                //pkxml += "\n<Exponent>" + Convert.ToBase64String(keys.Exponent) + "</Exponent>\n</root>";

                //String psxml = "<root>\n<Modulus>" + Convert.ToBase64String(keys.Modulus) + "</Modulus>";
                //psxml += "\n<Exponent>" + Convert.ToBase64String(keys.Exponent) + "</Exponent>";
                //psxml += "\n<D>" + Convert.ToBase64String(keys.D) + "</D>";
                //psxml += "\n<DP>" + Convert.ToBase64String(keys.DP) + "</DP>";
                //psxml += "\n<P>" + Convert.ToBase64String(keys.P) + "</P>";
                //psxml += "\n<Q>" + Convert.ToBase64String(keys.Q) + "</Q>";
                //psxml += "\n<DQ>" + Convert.ToBase64String(keys.DQ) + "</DQ>";
                //psxml += "\n<InverseQ>" + Convert.ToBase64String(keys.InverseQ) + "</InverseQ>\n</root>";

                //Console.WriteLine(rsa.ToXmlString(true));
                ////if(argv.Length>0&&argv[0]=="SaveToFile"){
                //SaveToFile("publickey.xml", pkxml);
                //SaveToFile("privatekey.xml", psxml);
                //Console.WriteLine("RSA Key保存成功！");

                //Console.WriteLine("PublicKey:\n" + pkxml);
                //Console.WriteLine("\nPrivateKey:\n" + psxml);

                //RSAHandler rsahd = new RSAHandler();
                //RSACryptoServiceProvider rsaprd = rsahd.CreateRSAProvider("privatekey.xml");
                //RSACryptoServiceProvider rsaprd1 = rsahd.CreateRSAEncryptProvider("publickey.xml");
                //String key = new string('c', 16);
                //string nativeString = "cbcye.com";
                //Console.WriteLine("Key:{0} | String: {1}", key,nativeString);
                //string encryptString = AESHelper.EncryptString(nativeString, key);
                //byte[] data = new UnicodeEncoding().GetBytes(key);
                //byte[] endata = rsaprd1.Encrypt(data, true);
                //Console.WriteLine("Encrypt Key:{0} | Encrypt String: {1}", Convert.ToBase64String(endata), encryptString);
                //Console.WriteLine();

                //byte[] dedata = rsaprd.Decrypt(endata, true);
                //Console.WriteLine("Decrypt Key:{0}", (new UnicodeEncoding()).GetString(dedata));
                //Console.WriteLine("Decrypt Native String: " + AESHelper.DecryptString(encryptString, (new UnicodeEncoding()).GetString(dedata)));
                #endregion

                #region 非对称密钥加解密ＸＭＬ

                //string strXML = "<root><creditcard><number>www.cbcye.com</number><expiry>04/30/1986</expiry></creditcard></root>";

                //Console.WriteLine("Source XML: \n" + strXML);
                //string encryptXml = RSAXMLDemo.EncryptXML(strXML);
                //Console.WriteLine("\n Encrypt XML: \n" + encryptXml);

                //string descryptXml = RSAXMLDemo.DescryptXML(encryptXml);
                //Console.WriteLine("\n Descrypt XML: \n" + descryptXml);
                #endregion
            }
            DateTime stopTime = DateTime.Now;
            TimeSpan ts1 = new TimeSpan(startTime.Ticks);
            TimeSpan ts2 = new TimeSpan(stopTime.Ticks);
            TimeSpan ts = ts2.Subtract(ts1).Duration();
            Console.WriteLine("执行时间:" + ts.TotalMilliseconds + "毫秒");
            Console.Read();
        }

        //保存文件
        static void SaveToFile(String filename, String data)
        {
            System.IO.StreamWriter sw = System.IO.File.CreateText(filename);
            sw.Write(data);
            sw.Close();
        }
    }
}
